from ctypes import *


class C_Library(object):
    def __init__(self, path: str, retype: type):
        self.path: str = path
        self.lib: _DLLT = cdll.LoadLibrary(path)
        self.lib.main.restype = retype
        self.func = self.lib.main

    def main(self, *args):
        return self.func(*args)

    def other(self, name: str, retype: type, *args):
        local_func = getattr(self.lib, name)
        local_func.restype = retype
        return local_func(*args)
